#include<stdio.h>
main()
{
	int N,O, A, B, AB,n,i;
	char krvna_grupa[2];
	printf("Unesi broj pacijenata: ");
	scanf("%d",&N);
	printf("Broj jedinica krvi u zalihama O, A, B, AB: ");
	scanf("%d %d %d %d",&O,&A,&B,&AB);
	for(i=0;i<N;i++)
	{
		printf("Unesi ");
		scanf("%s %d",krvna_grupa,&n);
	}
	for(i=0;i<N;i++)
	{
		if(krvna_grupa[0]=='O')
		{
			if(O>=n)
			{
				printf("%d,0,0,0",n);
			}
			else
			{
				printf("Nemoguce");
			}
			
		}
		if(krvna_grupa[0]=='A')
		{
			if(A>=n)
			{
				printf("0,%d,0,0",n);
			}
			else if(A>0&&O>n)
			{
				O-=A+n;
				printf("%c,%d,0,0",O,n);
			}
			else{
					printf("Nemoguce");
				}
		}
		else if(krvna_grupa[0]=='B')
		{
			if(B>=n)
			{
				printf("0,%d,0,0",n);
			}
			else if(B>0&&O>n)
			{
				O-=B+n;
				printf("%c,0,%d,0",O,n);
			}
			else{
					printf("Nemoguce");
				}
		}
		else if(krvna_grupa[0]=='A'&&krvna_grupa[1]=='B')
		{
			if(AB>=n)
			{
				printf("0,0,0,%c",n);
			}
			else
			{
				AB-=AB-n;
				if(A>=AB)
				{
					printf("0,%c,0,%c",AB,n);
				}
				else if(B>=AB)
				{
					printf("0,0,%c,%c",AB,n);
				}
				else if(O>=AB)
				{
					printf("%c,0,0,%c",AB,n);
				}
				else{
					printf("Nemoguce");
				}
			}
		}
	}

}